<!DOCTYPE html><html lang="en"><head><meta charset="utf-8"><meta name="viewport" content="width=device-width, initial-scale=1.0"><meta name="generator" content="rustdoc"><meta name="description" content="Source to the Rust file `/home/keir/.cargo/registry/src/github.com-1ecc6299db9ec823/getrandom-0.1.15/src/lib.rs`."><meta name="keywords" content="rust, rustlang, rust-lang"><title>lib.rs.html -- source</title><link rel="stylesheet" type="text/css" href="../../normalize.css"><link rel="stylesheet" type="text/css" href="../../rustdoc.css" id="mainThemeStyle"><link rel="stylesheet" type="text/css" href="../../dark.css"><link rel="stylesheet" type="text/css" href="../../light.css" id="themeStyle"><script src="../../storage.js"></script><noscript><link rel="stylesheet" href="../../noscript.css"></noscript><link rel="shortcut icon" href="https://www.rust-lang.org/favicon.ico"><style type="text/css">#crate-search{background-image:url("../../down-arrow.svg");}</style></head><body class="rustdoc source"><!--[if lte IE 8]><div class="warning">This old browser is unsupported and will most likely display funky things.</div><![endif]--><nav class="sidebar"><div class="sidebar-menu">&#9776;</div><a href='../../getrandom/index.html'><div class='logo-container'><img src='https://www.rust-lang.org/logos/rust-logo-128x128-blk.png' alt='logo'></div></a></nav><div class="theme-picker"><button id="theme-picker" aria-label="Pick another theme!"><img src="../../brush.svg" width="18" alt="Pick another theme!"></button><div id="theme-choices"></div></div><script src="../../theme.js"></script><nav class="sub"><form class="search-form"><div class="search-container"><div><select id="crate-search"><option value="All crates">All crates</option></select><input class="search-input" name="search" disabled autocomplete="off" spellcheck="false" placeholder="Click or press ‘S’ to search, ‘?’ for more options…" type="search"></div><a id="settings-menu" href="../../settings.html"><img src="../../wheel.svg" width="18" alt="Change settings"></a></div></form></nav><section id="main" class="content"><pre class="line-numbers"><span id="1">  1</span>
<span id="2">  2</span>
<span id="3">  3</span>
<span id="4">  4</span>
<span id="5">  5</span>
<span id="6">  6</span>
<span id="7">  7</span>
<span id="8">  8</span>
<span id="9">  9</span>
<span id="10"> 10</span>
<span id="11"> 11</span>
<span id="12"> 12</span>
<span id="13"> 13</span>
<span id="14"> 14</span>
<span id="15"> 15</span>
<span id="16"> 16</span>
<span id="17"> 17</span>
<span id="18"> 18</span>
<span id="19"> 19</span>
<span id="20"> 20</span>
<span id="21"> 21</span>
<span id="22"> 22</span>
<span id="23"> 23</span>
<span id="24"> 24</span>
<span id="25"> 25</span>
<span id="26"> 26</span>
<span id="27"> 27</span>
<span id="28"> 28</span>
<span id="29"> 29</span>
<span id="30"> 30</span>
<span id="31"> 31</span>
<span id="32"> 32</span>
<span id="33"> 33</span>
<span id="34"> 34</span>
<span id="35"> 35</span>
<span id="36"> 36</span>
<span id="37"> 37</span>
<span id="38"> 38</span>
<span id="39"> 39</span>
<span id="40"> 40</span>
<span id="41"> 41</span>
<span id="42"> 42</span>
<span id="43"> 43</span>
<span id="44"> 44</span>
<span id="45"> 45</span>
<span id="46"> 46</span>
<span id="47"> 47</span>
<span id="48"> 48</span>
<span id="49"> 49</span>
<span id="50"> 50</span>
<span id="51"> 51</span>
<span id="52"> 52</span>
<span id="53"> 53</span>
<span id="54"> 54</span>
<span id="55"> 55</span>
<span id="56"> 56</span>
<span id="57"> 57</span>
<span id="58"> 58</span>
<span id="59"> 59</span>
<span id="60"> 60</span>
<span id="61"> 61</span>
<span id="62"> 62</span>
<span id="63"> 63</span>
<span id="64"> 64</span>
<span id="65"> 65</span>
<span id="66"> 66</span>
<span id="67"> 67</span>
<span id="68"> 68</span>
<span id="69"> 69</span>
<span id="70"> 70</span>
<span id="71"> 71</span>
<span id="72"> 72</span>
<span id="73"> 73</span>
<span id="74"> 74</span>
<span id="75"> 75</span>
<span id="76"> 76</span>
<span id="77"> 77</span>
<span id="78"> 78</span>
<span id="79"> 79</span>
<span id="80"> 80</span>
<span id="81"> 81</span>
<span id="82"> 82</span>
<span id="83"> 83</span>
<span id="84"> 84</span>
<span id="85"> 85</span>
<span id="86"> 86</span>
<span id="87"> 87</span>
<span id="88"> 88</span>
<span id="89"> 89</span>
<span id="90"> 90</span>
<span id="91"> 91</span>
<span id="92"> 92</span>
<span id="93"> 93</span>
<span id="94"> 94</span>
<span id="95"> 95</span>
<span id="96"> 96</span>
<span id="97"> 97</span>
<span id="98"> 98</span>
<span id="99"> 99</span>
<span id="100">100</span>
<span id="101">101</span>
<span id="102">102</span>
<span id="103">103</span>
<span id="104">104</span>
<span id="105">105</span>
<span id="106">106</span>
<span id="107">107</span>
<span id="108">108</span>
<span id="109">109</span>
<span id="110">110</span>
<span id="111">111</span>
<span id="112">112</span>
<span id="113">113</span>
<span id="114">114</span>
<span id="115">115</span>
<span id="116">116</span>
<span id="117">117</span>
<span id="118">118</span>
<span id="119">119</span>
<span id="120">120</span>
<span id="121">121</span>
<span id="122">122</span>
<span id="123">123</span>
<span id="124">124</span>
<span id="125">125</span>
<span id="126">126</span>
<span id="127">127</span>
<span id="128">128</span>
<span id="129">129</span>
<span id="130">130</span>
<span id="131">131</span>
<span id="132">132</span>
<span id="133">133</span>
<span id="134">134</span>
<span id="135">135</span>
<span id="136">136</span>
<span id="137">137</span>
<span id="138">138</span>
<span id="139">139</span>
<span id="140">140</span>
<span id="141">141</span>
<span id="142">142</span>
<span id="143">143</span>
<span id="144">144</span>
<span id="145">145</span>
<span id="146">146</span>
<span id="147">147</span>
<span id="148">148</span>
<span id="149">149</span>
<span id="150">150</span>
<span id="151">151</span>
<span id="152">152</span>
<span id="153">153</span>
<span id="154">154</span>
<span id="155">155</span>
<span id="156">156</span>
<span id="157">157</span>
<span id="158">158</span>
<span id="159">159</span>
<span id="160">160</span>
<span id="161">161</span>
<span id="162">162</span>
<span id="163">163</span>
<span id="164">164</span>
<span id="165">165</span>
<span id="166">166</span>
<span id="167">167</span>
<span id="168">168</span>
<span id="169">169</span>
<span id="170">170</span>
<span id="171">171</span>
<span id="172">172</span>
<span id="173">173</span>
<span id="174">174</span>
<span id="175">175</span>
<span id="176">176</span>
<span id="177">177</span>
<span id="178">178</span>
<span id="179">179</span>
<span id="180">180</span>
<span id="181">181</span>
<span id="182">182</span>
<span id="183">183</span>
<span id="184">184</span>
<span id="185">185</span>
<span id="186">186</span>
<span id="187">187</span>
<span id="188">188</span>
<span id="189">189</span>
<span id="190">190</span>
<span id="191">191</span>
<span id="192">192</span>
<span id="193">193</span>
<span id="194">194</span>
<span id="195">195</span>
<span id="196">196</span>
<span id="197">197</span>
<span id="198">198</span>
<span id="199">199</span>
<span id="200">200</span>
<span id="201">201</span>
<span id="202">202</span>
<span id="203">203</span>
<span id="204">204</span>
<span id="205">205</span>
<span id="206">206</span>
<span id="207">207</span>
<span id="208">208</span>
<span id="209">209</span>
<span id="210">210</span>
<span id="211">211</span>
<span id="212">212</span>
<span id="213">213</span>
<span id="214">214</span>
<span id="215">215</span>
<span id="216">216</span>
<span id="217">217</span>
<span id="218">218</span>
<span id="219">219</span>
<span id="220">220</span>
<span id="221">221</span>
<span id="222">222</span>
<span id="223">223</span>
<span id="224">224</span>
<span id="225">225</span>
<span id="226">226</span>
<span id="227">227</span>
<span id="228">228</span>
<span id="229">229</span>
<span id="230">230</span>
<span id="231">231</span>
<span id="232">232</span>
<span id="233">233</span>
<span id="234">234</span>
<span id="235">235</span>
<span id="236">236</span>
<span id="237">237</span>
<span id="238">238</span>
<span id="239">239</span>
<span id="240">240</span>
<span id="241">241</span>
<span id="242">242</span>
<span id="243">243</span>
<span id="244">244</span>
<span id="245">245</span>
<span id="246">246</span>
<span id="247">247</span>
<span id="248">248</span>
<span id="249">249</span>
<span id="250">250</span>
<span id="251">251</span>
<span id="252">252</span>
<span id="253">253</span>
<span id="254">254</span>
<span id="255">255</span>
<span id="256">256</span>
<span id="257">257</span>
<span id="258">258</span>
<span id="259">259</span>
<span id="260">260</span>
<span id="261">261</span>
<span id="262">262</span>
<span id="263">263</span>
<span id="264">264</span>
<span id="265">265</span>
<span id="266">266</span>
<span id="267">267</span>
<span id="268">268</span>
<span id="269">269</span>
<span id="270">270</span>
<span id="271">271</span>
<span id="272">272</span>
<span id="273">273</span>
<span id="274">274</span>
<span id="275">275</span>
<span id="276">276</span>
<span id="277">277</span>
<span id="278">278</span>
<span id="279">279</span>
<span id="280">280</span>
<span id="281">281</span>
<span id="282">282</span>
</pre><div class="example-wrap"><pre class="rust ">
<span class="comment">// Copyright 2019 Developers of the Rand project.</span>
<span class="comment">//</span>
<span class="comment">// Licensed under the Apache License, Version 2.0 &lt;LICENSE-APACHE or</span>
<span class="comment">// https://www.apache.org/licenses/LICENSE-2.0&gt; or the MIT license</span>
<span class="comment">// &lt;LICENSE-MIT or https://opensource.org/licenses/MIT&gt;, at your</span>
<span class="comment">// option. This file may not be copied, modified, or distributed</span>
<span class="comment">// except according to those terms.</span>

<span class="doccomment">//! Interface to the random number generator of the operating system.</span>
<span class="doccomment">//!</span>
<span class="doccomment">//! # Platform sources</span>
<span class="doccomment">//!</span>
<span class="doccomment">//! | OS               | interface</span>
<span class="doccomment">//! |------------------|---------------------------------------------------------</span>
<span class="doccomment">//! | Linux, Android   | [`getrandom`][1] system call if available, otherwise [`/dev/urandom`][2] after successfully polling `/dev/random`</span>
<span class="doccomment">//! | Windows          | [`RtlGenRandom`][3]</span>
<span class="doccomment">//! | macOS            | [`getentropy()`][19] if available, otherwise [`/dev/random`][20] (identical to `/dev/urandom`)</span>
<span class="doccomment">//! | iOS              | [`SecRandomCopyBytes`][4]</span>
<span class="doccomment">//! | FreeBSD          | [`getrandom()`][21] if available, otherwise [`kern.arandom`][5]</span>
<span class="doccomment">//! | OpenBSD          | [`getentropy`][6]</span>
<span class="doccomment">//! | NetBSD           | [`kern.arandom`][7]</span>
<span class="doccomment">//! | Dragonfly BSD    | [`/dev/random`][8]</span>
<span class="doccomment">//! | Solaris, illumos | [`getrandom`][9] system call if available, otherwise [`/dev/random`][10]</span>
<span class="doccomment">//! | Fuchsia OS       | [`cprng_draw`][11]</span>
<span class="doccomment">//! | Redox            | [`rand:`][12]</span>
<span class="doccomment">//! | CloudABI         | [`cloudabi_sys_random_get`][13]</span>
<span class="doccomment">//! | Haiku            | `/dev/random` (identical to `/dev/urandom`)</span>
<span class="doccomment">//! | L4RE, SGX, UEFI  | [RDRAND][18]</span>
<span class="doccomment">//! | Hermit           | [RDRAND][18] as [`sys_rand`][22] is currently broken.</span>
<span class="doccomment">//! | VxWorks          | `randABytes` after checking entropy pool initialization with `randSecure`</span>
<span class="doccomment">//! | Web browsers     | [`Crypto.getRandomValues`][14] (see [Support for WebAssembly and asm.js][16])</span>
<span class="doccomment">//! | Node.js          | [`crypto.randomBytes`][15] (see [Support for WebAssembly and asm.js][16])</span>
<span class="doccomment">//! | WASI             | [`__wasi_random_get`][17]</span>
<span class="doccomment">//!</span>
<span class="doccomment">//! Getrandom doesn&#39;t have a blanket implementation for all Unix-like operating</span>
<span class="doccomment">//! systems that reads from `/dev/urandom`. This ensures all supported operating</span>
<span class="doccomment">//! systems are using the recommended interface and respect maximum buffer</span>
<span class="doccomment">//! sizes.</span>
<span class="doccomment">//!</span>
<span class="doccomment">//! ## Unsupported targets</span>
<span class="doccomment">//!</span>
<span class="doccomment">//! By default, compiling `getrandom` for an unsupported target will result in</span>
<span class="doccomment">//! a compilation error. If you want to build an application which uses `getrandom`</span>
<span class="doccomment">//! for such target, you can either:</span>
<span class="doccomment">//! - Use [`[replace]`][replace] or [`[patch]`][patch] section in your `Cargo.toml`</span>
<span class="doccomment">//! to switch to a custom implementation with a support of your target.</span>
<span class="doccomment">//! - Enable the `dummy` feature to have getrandom use an implementation that always</span>
<span class="doccomment">//! fails at run-time on unsupported targets.</span>
<span class="doccomment">//!</span>
<span class="doccomment">//! [replace]: https://doc.rust-lang.org/cargo/reference/manifest.html#the-replace-section</span>
<span class="doccomment">//! [patch]: https://doc.rust-lang.org/cargo/reference/manifest.html#the-patch-section</span>
<span class="doccomment">//!</span>
<span class="doccomment">//! ## Support for WebAssembly and asm.js</span>
<span class="doccomment">//!</span>
<span class="doccomment">//! Getrandom supports all of Rust&#39;s current `wasm32` targets, and it works with</span>
<span class="doccomment">//! both Node.js and web browsers. The three Emscripten targets</span>
<span class="doccomment">//! `asmjs-unknown-emscripten`, `wasm32-unknown-emscripten`, and</span>
<span class="doccomment">//! `wasm32-experimental-emscripten` use Emscripten&#39;s `/dev/random` emulation.</span>
<span class="doccomment">//! The WASI target `wasm32-wasi` uses the [`__wasi_random_get`][17] function</span>
<span class="doccomment">//! defined by the WASI standard.</span>
<span class="doccomment">//!</span>
<span class="doccomment">//! Getrandom also supports `wasm32-unknown-unknown` by directly calling</span>
<span class="doccomment">//! JavaScript methods. Rust currently has two ways to do this: [bindgen] and</span>
<span class="doccomment">//! [stdweb]. Getrandom supports using either one by enabling the</span>
<span class="doccomment">//! `wasm-bindgen` or `stdweb` crate features. Note that if both features are</span>
<span class="doccomment">//! enabled, `wasm-bindgen` will be used. If neither feature is enabled, calls</span>
<span class="doccomment">//! to `getrandom` will always fail at runtime.</span>
<span class="doccomment">//!</span>
<span class="doccomment">//! [bindgen]: https://github.com/rust-lang/rust-bindgen</span>
<span class="doccomment">//! [stdweb]: https://github.com/koute/stdweb</span>
<span class="doccomment">//!</span>
<span class="doccomment">//! ## Early boot</span>
<span class="doccomment">//!</span>
<span class="doccomment">//! It is possible that early in the boot process the OS hasn&#39;t had enough time</span>
<span class="doccomment">//! yet to collect entropy to securely seed its RNG, especially on virtual</span>
<span class="doccomment">//! machines.</span>
<span class="doccomment">//!</span>
<span class="doccomment">//! Some operating systems always block the thread until the RNG is securely</span>
<span class="doccomment">//! seeded. This can take anywhere from a few seconds to more than a minute.</span>
<span class="doccomment">//! Others make a best effort to use a seed from before the shutdown and don&#39;t</span>
<span class="doccomment">//! document much.</span>
<span class="doccomment">//!</span>
<span class="doccomment">//! A few, Linux, NetBSD and Solaris, offer a choice between blocking and</span>
<span class="doccomment">//! getting an error; in these cases we always choose to block.</span>
<span class="doccomment">//!</span>
<span class="doccomment">//! On Linux (when the `getrandom` system call is not available) and on NetBSD</span>
<span class="doccomment">//! reading from `/dev/urandom` never blocks, even when the OS hasn&#39;t collected</span>
<span class="doccomment">//! enough entropy yet. To avoid returning low-entropy bytes, we first read from</span>
<span class="doccomment">//! `/dev/random` and only switch to `/dev/urandom` once this has succeeded.</span>
<span class="doccomment">//!</span>
<span class="doccomment">//! # Error handling</span>
<span class="doccomment">//!</span>
<span class="doccomment">//! We always choose failure over returning insecure &quot;random&quot; bytes. In general,</span>
<span class="doccomment">//! on supported platforms, failure is highly unlikely, though not impossible.</span>
<span class="doccomment">//! If an error does occur, then it is likely that it will occur on every call to</span>
<span class="doccomment">//! `getrandom`, hence after the first successful call one can be reasonably</span>
<span class="doccomment">//! confident that no errors will occur.</span>
<span class="doccomment">//!</span>
<span class="doccomment">//! On unsupported platforms, `getrandom` always fails. See the [`Error`] type</span>
<span class="doccomment">//! for more information on what data is returned on failure.</span>
<span class="doccomment">//!</span>
<span class="doccomment">//! [1]: http://man7.org/linux/man-pages/man2/getrandom.2.html</span>
<span class="doccomment">//! [2]: http://man7.org/linux/man-pages/man4/urandom.4.html</span>
<span class="doccomment">//! [3]: https://docs.microsoft.com/en-us/windows/desktop/api/ntsecapi/nf-ntsecapi-rtlgenrandom</span>
<span class="doccomment">//! [4]: https://developer.apple.com/documentation/security/1399291-secrandomcopybytes?language=objc</span>
<span class="doccomment">//! [5]: https://www.freebsd.org/cgi/man.cgi?query=random&amp;sektion=4</span>
<span class="doccomment">//! [6]: https://man.openbsd.org/getentropy.2</span>
<span class="doccomment">//! [7]: https://netbsd.gw.com/cgi-bin/man-cgi?sysctl+7+NetBSD-8.0</span>
<span class="doccomment">//! [8]: https://leaf.dragonflybsd.org/cgi/web-man?command=random&amp;section=4</span>
<span class="doccomment">//! [9]: https://docs.oracle.com/cd/E88353_01/html/E37841/getrandom-2.html</span>
<span class="doccomment">//! [10]: https://docs.oracle.com/cd/E86824_01/html/E54777/random-7d.html</span>
<span class="doccomment">//! [11]: https://fuchsia.dev/fuchsia-src/zircon/syscalls/cprng_draw</span>
<span class="doccomment">//! [12]: https://github.com/redox-os/randd/blob/master/src/main.rs</span>
<span class="doccomment">//! [13]: https://github.com/nuxinl/cloudabi#random_get</span>
<span class="doccomment">//! [14]: https://www.w3.org/TR/WebCryptoAPI/#Crypto-method-getRandomValues</span>
<span class="doccomment">//! [15]: https://nodejs.org/api/crypto.html#crypto_crypto_randombytes_size_callback</span>
<span class="doccomment">//! [16]: #support-for-webassembly-and-asmjs</span>
<span class="doccomment">//! [17]: https://github.com/WebAssembly/WASI/blob/master/design/WASI-core.md#__wasi_random_get</span>
<span class="doccomment">//! [18]: https://software.intel.com/en-us/articles/intel-digital-random-number-generator-drng-software-implementation-guide</span>
<span class="doccomment">//! [19]: https://www.unix.com/man-page/mojave/2/getentropy/</span>
<span class="doccomment">//! [20]: https://www.unix.com/man-page/mojave/4/random/</span>
<span class="doccomment">//! [21]: https://www.freebsd.org/cgi/man.cgi?query=getrandom&amp;manpath=FreeBSD+12.0-stable</span>
<span class="doccomment">//! [22]: https://github.com/hermitcore/libhermit-rs/blob/09c38b0371cee6f56a541400ba453e319e43db53/src/syscalls/random.rs#L21</span>

<span class="attribute">#![<span class="ident">doc</span>(
    <span class="ident">html_logo_url</span> <span class="op">=</span> <span class="string">&quot;https://www.rust-lang.org/logos/rust-logo-128x128-blk.png&quot;</span>,
    <span class="ident">html_favicon_url</span> <span class="op">=</span> <span class="string">&quot;https://www.rust-lang.org/favicon.ico&quot;</span>,
    <span class="ident">html_root_url</span> <span class="op">=</span> <span class="string">&quot;https://rust-random.github.io/rand/&quot;</span>
)]</span>
<span class="attribute">#![<span class="ident">no_std</span>]</span>
<span class="attribute">#![<span class="ident">cfg_attr</span>(<span class="ident">feature</span> <span class="op">=</span> <span class="string">&quot;stdweb&quot;</span>, <span class="ident">recursion_limit</span> <span class="op">=</span> <span class="string">&quot;128&quot;</span>)]</span>
<span class="attribute">#![<span class="ident">warn</span>(<span class="ident">rust_2018_idioms</span>, <span class="ident">unused_lifetimes</span>, <span class="ident">missing_docs</span>)]</span>

<span class="attribute">#[<span class="ident">macro_use</span>]</span>
<span class="kw">extern</span> <span class="kw">crate</span> <span class="ident">cfg_if</span>;

<span class="macro">cfg_if</span><span class="macro">!</span> {
    <span class="kw">if</span> <span class="attribute">#[<span class="ident">cfg</span>(<span class="ident">feature</span> <span class="op">=</span> <span class="string">&quot;log&quot;</span>)]</span> {
        <span class="attribute">#[<span class="ident">allow</span>(<span class="ident">unused</span>)]</span>
        <span class="attribute">#[<span class="ident">macro_use</span>]</span>
        <span class="kw">extern</span> <span class="kw">crate</span> <span class="ident">log</span>;
    } <span class="kw">else</span> {
        <span class="attribute">#[<span class="ident">allow</span>(<span class="ident">unused</span>)]</span>
        <span class="macro">macro_rules</span><span class="macro">!</span> <span class="ident">error</span> {
            ($(<span class="macro-nonterminal">$</span><span class="macro-nonterminal">x</span>:<span class="ident">tt</span>)<span class="kw-2">*</span>) <span class="op">=</span><span class="op">&gt;</span> {};
        }
        <span class="attribute">#[<span class="ident">allow</span>(<span class="ident">unused</span>)]</span>
        <span class="macro">macro_rules</span><span class="macro">!</span> <span class="ident">warn</span> {
            ($(<span class="macro-nonterminal">$</span><span class="macro-nonterminal">x</span>:<span class="ident">tt</span>)<span class="kw-2">*</span>) <span class="op">=</span><span class="op">&gt;</span> {};
        }
        <span class="attribute">#[<span class="ident">allow</span>(<span class="ident">unused</span>)]</span>
        <span class="macro">macro_rules</span><span class="macro">!</span> <span class="ident">info</span> {
            ($(<span class="macro-nonterminal">$</span><span class="macro-nonterminal">x</span>:<span class="ident">tt</span>)<span class="kw-2">*</span>) <span class="op">=</span><span class="op">&gt;</span> {};
        }
    }
}

<span class="kw">mod</span> <span class="ident">error</span>;
<span class="kw">pub</span> <span class="kw">use</span> <span class="kw">crate</span>::<span class="ident">error</span>::<span class="ident">Error</span>;

<span class="attribute">#[<span class="ident">allow</span>(<span class="ident">dead_code</span>)]</span>
<span class="kw">mod</span> <span class="ident">util</span>;

<span class="attribute">#[<span class="ident">cfg</span>(<span class="ident">target_os</span> <span class="op">=</span> <span class="string">&quot;vxworks&quot;</span>)]</span>
<span class="attribute">#[<span class="ident">allow</span>(<span class="ident">dead_code</span>)]</span>
<span class="kw">mod</span> <span class="ident">util_libc</span>;

<span class="macro">cfg_if</span><span class="macro">!</span> {
    <span class="comment">// Unlike the other Unix, Fuchsia and iOS don&#39;t use the libc to make any calls.</span>
    <span class="kw">if</span> <span class="attribute">#[<span class="ident">cfg</span>(<span class="ident">any</span>(<span class="ident">target_os</span> <span class="op">=</span> <span class="string">&quot;android&quot;</span>, <span class="ident">target_os</span> <span class="op">=</span> <span class="string">&quot;dragonfly&quot;</span>, <span class="ident">target_os</span> <span class="op">=</span> <span class="string">&quot;emscripten&quot;</span>,
                 <span class="ident">target_os</span> <span class="op">=</span> <span class="string">&quot;freebsd&quot;</span>, <span class="ident">target_os</span> <span class="op">=</span> <span class="string">&quot;haiku&quot;</span>,     <span class="ident">target_os</span> <span class="op">=</span> <span class="string">&quot;illumos&quot;</span>,
                 <span class="ident">target_os</span> <span class="op">=</span> <span class="string">&quot;linux&quot;</span>,   <span class="ident">target_os</span> <span class="op">=</span> <span class="string">&quot;macos&quot;</span>,     <span class="ident">target_os</span> <span class="op">=</span> <span class="string">&quot;netbsd&quot;</span>,
                 <span class="ident">target_os</span> <span class="op">=</span> <span class="string">&quot;openbsd&quot;</span>, <span class="ident">target_os</span> <span class="op">=</span> <span class="string">&quot;redox&quot;</span>,     <span class="ident">target_os</span> <span class="op">=</span> <span class="string">&quot;solaris&quot;</span>))]</span> {
        <span class="attribute">#[<span class="ident">allow</span>(<span class="ident">dead_code</span>)]</span>
        <span class="kw">mod</span> <span class="ident">util_libc</span>;
        <span class="comment">// Keep std-only trait definitions for backwards compatibility</span>
        <span class="kw">mod</span> <span class="ident">error_impls</span>;
    } <span class="kw">else</span> <span class="kw">if</span> <span class="attribute">#[<span class="ident">cfg</span>(<span class="ident">feature</span> <span class="op">=</span> <span class="string">&quot;std&quot;</span>)]</span> {
        <span class="kw">mod</span> <span class="ident">error_impls</span>;
    }
}

<span class="comment">// These targets read from a file as a fallback method.</span>
<span class="attribute">#[<span class="ident">cfg</span>(<span class="ident">any</span>(
    <span class="ident">target_os</span> <span class="op">=</span> <span class="string">&quot;android&quot;</span>,
    <span class="ident">target_os</span> <span class="op">=</span> <span class="string">&quot;linux&quot;</span>,
    <span class="ident">target_os</span> <span class="op">=</span> <span class="string">&quot;macos&quot;</span>,
    <span class="ident">target_os</span> <span class="op">=</span> <span class="string">&quot;solaris&quot;</span>,
    <span class="ident">target_os</span> <span class="op">=</span> <span class="string">&quot;illumos&quot;</span>,
))]</span>
<span class="kw">mod</span> <span class="ident">use_file</span>;

<span class="comment">// System-specific implementations.</span>
<span class="comment">//</span>
<span class="comment">// These should all provide getrandom_inner with the same signature as getrandom.</span>
<span class="macro">cfg_if</span><span class="macro">!</span> {
    <span class="kw">if</span> <span class="attribute">#[<span class="ident">cfg</span>(<span class="ident">target_os</span> <span class="op">=</span> <span class="string">&quot;android&quot;</span>)]</span> {
        <span class="attribute">#[<span class="ident">path</span> <span class="op">=</span> <span class="string">&quot;linux_android.rs&quot;</span>]</span> <span class="kw">mod</span> <span class="ident">imp</span>;
    } <span class="kw">else</span> <span class="kw">if</span> <span class="attribute">#[<span class="ident">cfg</span>(<span class="ident">target_os</span> <span class="op">=</span> <span class="string">&quot;cloudabi&quot;</span>)]</span> {
        <span class="attribute">#[<span class="ident">path</span> <span class="op">=</span> <span class="string">&quot;cloudabi.rs&quot;</span>]</span> <span class="kw">mod</span> <span class="ident">imp</span>;
    } <span class="kw">else</span> <span class="kw">if</span> <span class="attribute">#[<span class="ident">cfg</span>(<span class="ident">target_os</span> <span class="op">=</span> <span class="string">&quot;dragonfly&quot;</span>)]</span> {
        <span class="attribute">#[<span class="ident">path</span> <span class="op">=</span> <span class="string">&quot;use_file.rs&quot;</span>]</span> <span class="kw">mod</span> <span class="ident">imp</span>;
    } <span class="kw">else</span> <span class="kw">if</span> <span class="attribute">#[<span class="ident">cfg</span>(<span class="ident">target_os</span> <span class="op">=</span> <span class="string">&quot;emscripten&quot;</span>)]</span> {
        <span class="attribute">#[<span class="ident">path</span> <span class="op">=</span> <span class="string">&quot;use_file.rs&quot;</span>]</span> <span class="kw">mod</span> <span class="ident">imp</span>;
    } <span class="kw">else</span> <span class="kw">if</span> <span class="attribute">#[<span class="ident">cfg</span>(<span class="ident">target_os</span> <span class="op">=</span> <span class="string">&quot;freebsd&quot;</span>)]</span> {
        <span class="attribute">#[<span class="ident">path</span> <span class="op">=</span> <span class="string">&quot;bsd_arandom.rs&quot;</span>]</span> <span class="kw">mod</span> <span class="ident">imp</span>;
    } <span class="kw">else</span> <span class="kw">if</span> <span class="attribute">#[<span class="ident">cfg</span>(<span class="ident">target_os</span> <span class="op">=</span> <span class="string">&quot;fuchsia&quot;</span>)]</span> {
        <span class="attribute">#[<span class="ident">path</span> <span class="op">=</span> <span class="string">&quot;fuchsia.rs&quot;</span>]</span> <span class="kw">mod</span> <span class="ident">imp</span>;
    } <span class="kw">else</span> <span class="kw">if</span> <span class="attribute">#[<span class="ident">cfg</span>(<span class="ident">target_os</span> <span class="op">=</span> <span class="string">&quot;haiku&quot;</span>)]</span> {
        <span class="attribute">#[<span class="ident">path</span> <span class="op">=</span> <span class="string">&quot;use_file.rs&quot;</span>]</span> <span class="kw">mod</span> <span class="ident">imp</span>;
    } <span class="kw">else</span> <span class="kw">if</span> <span class="attribute">#[<span class="ident">cfg</span>(<span class="ident">target_os</span> <span class="op">=</span> <span class="string">&quot;illumos&quot;</span>)]</span> {
        <span class="attribute">#[<span class="ident">path</span> <span class="op">=</span> <span class="string">&quot;solaris_illumos.rs&quot;</span>]</span> <span class="kw">mod</span> <span class="ident">imp</span>;
    } <span class="kw">else</span> <span class="kw">if</span> <span class="attribute">#[<span class="ident">cfg</span>(<span class="ident">target_os</span> <span class="op">=</span> <span class="string">&quot;ios&quot;</span>)]</span> {
        <span class="attribute">#[<span class="ident">path</span> <span class="op">=</span> <span class="string">&quot;ios.rs&quot;</span>]</span> <span class="kw">mod</span> <span class="ident">imp</span>;
    } <span class="kw">else</span> <span class="kw">if</span> <span class="attribute">#[<span class="ident">cfg</span>(<span class="ident">target_os</span> <span class="op">=</span> <span class="string">&quot;linux&quot;</span>)]</span> {
        <span class="attribute">#[<span class="ident">path</span> <span class="op">=</span> <span class="string">&quot;linux_android.rs&quot;</span>]</span> <span class="kw">mod</span> <span class="ident">imp</span>;
    } <span class="kw">else</span> <span class="kw">if</span> <span class="attribute">#[<span class="ident">cfg</span>(<span class="ident">target_os</span> <span class="op">=</span> <span class="string">&quot;macos&quot;</span>)]</span> {
        <span class="attribute">#[<span class="ident">path</span> <span class="op">=</span> <span class="string">&quot;macos.rs&quot;</span>]</span> <span class="kw">mod</span> <span class="ident">imp</span>;
    } <span class="kw">else</span> <span class="kw">if</span> <span class="attribute">#[<span class="ident">cfg</span>(<span class="ident">target_os</span> <span class="op">=</span> <span class="string">&quot;netbsd&quot;</span>)]</span> {
        <span class="attribute">#[<span class="ident">path</span> <span class="op">=</span> <span class="string">&quot;bsd_arandom.rs&quot;</span>]</span> <span class="kw">mod</span> <span class="ident">imp</span>;
    } <span class="kw">else</span> <span class="kw">if</span> <span class="attribute">#[<span class="ident">cfg</span>(<span class="ident">target_os</span> <span class="op">=</span> <span class="string">&quot;openbsd&quot;</span>)]</span> {
        <span class="attribute">#[<span class="ident">path</span> <span class="op">=</span> <span class="string">&quot;openbsd.rs&quot;</span>]</span> <span class="kw">mod</span> <span class="ident">imp</span>;
    } <span class="kw">else</span> <span class="kw">if</span> <span class="attribute">#[<span class="ident">cfg</span>(<span class="ident">target_os</span> <span class="op">=</span> <span class="string">&quot;redox&quot;</span>)]</span> {
        <span class="attribute">#[<span class="ident">path</span> <span class="op">=</span> <span class="string">&quot;use_file.rs&quot;</span>]</span> <span class="kw">mod</span> <span class="ident">imp</span>;
    } <span class="kw">else</span> <span class="kw">if</span> <span class="attribute">#[<span class="ident">cfg</span>(<span class="ident">target_os</span> <span class="op">=</span> <span class="string">&quot;solaris&quot;</span>)]</span> {
        <span class="attribute">#[<span class="ident">path</span> <span class="op">=</span> <span class="string">&quot;solaris_illumos.rs&quot;</span>]</span> <span class="kw">mod</span> <span class="ident">imp</span>;
    } <span class="kw">else</span> <span class="kw">if</span> <span class="attribute">#[<span class="ident">cfg</span>(<span class="ident">target_os</span> <span class="op">=</span> <span class="string">&quot;wasi&quot;</span>)]</span> {
        <span class="attribute">#[<span class="ident">path</span> <span class="op">=</span> <span class="string">&quot;wasi.rs&quot;</span>]</span> <span class="kw">mod</span> <span class="ident">imp</span>;
    } <span class="kw">else</span> <span class="kw">if</span> <span class="attribute">#[<span class="ident">cfg</span>(<span class="ident">target_os</span> <span class="op">=</span> <span class="string">&quot;vxworks&quot;</span>)]</span> {
        <span class="attribute">#[<span class="ident">path</span> <span class="op">=</span> <span class="string">&quot;vxworks.rs&quot;</span>]</span> <span class="kw">mod</span> <span class="ident">imp</span>;
    } <span class="kw">else</span> <span class="kw">if</span> <span class="attribute">#[<span class="ident">cfg</span>(<span class="ident">all</span>(<span class="ident">windows</span>, <span class="ident">getrandom_uwp</span>))]</span> {
        <span class="attribute">#[<span class="ident">path</span> <span class="op">=</span> <span class="string">&quot;windows_uwp.rs&quot;</span>]</span> <span class="kw">mod</span> <span class="ident">imp</span>;
    } <span class="kw">else</span> <span class="kw">if</span> <span class="attribute">#[<span class="ident">cfg</span>(<span class="ident">windows</span>)]</span> {
        <span class="attribute">#[<span class="ident">path</span> <span class="op">=</span> <span class="string">&quot;windows.rs&quot;</span>]</span> <span class="kw">mod</span> <span class="ident">imp</span>;
    } <span class="kw">else</span> <span class="kw">if</span> <span class="attribute">#[<span class="ident">cfg</span>(<span class="ident">all</span>(<span class="ident">target_arch</span> <span class="op">=</span> <span class="string">&quot;x86_64&quot;</span>, <span class="ident">any</span>(
                  <span class="ident">target_os</span> <span class="op">=</span> <span class="string">&quot;hermit&quot;</span>,
                  <span class="ident">target_os</span> <span class="op">=</span> <span class="string">&quot;l4re&quot;</span>,
                  <span class="ident">target_os</span> <span class="op">=</span> <span class="string">&quot;uefi&quot;</span>,
                  <span class="ident">target_env</span> <span class="op">=</span> <span class="string">&quot;sgx&quot;</span>,
              )))]</span> {
        <span class="attribute">#[<span class="ident">path</span> <span class="op">=</span> <span class="string">&quot;rdrand.rs&quot;</span>]</span> <span class="kw">mod</span> <span class="ident">imp</span>;
    } <span class="kw">else</span> <span class="kw">if</span> <span class="attribute">#[<span class="ident">cfg</span>(<span class="ident">all</span>(<span class="ident">target_arch</span> <span class="op">=</span> <span class="string">&quot;wasm32&quot;</span>, <span class="ident">target_os</span> <span class="op">=</span> <span class="string">&quot;unknown&quot;</span>))]</span> {
        <span class="macro">cfg_if</span><span class="macro">!</span> {
            <span class="kw">if</span> <span class="attribute">#[<span class="ident">cfg</span>(<span class="ident">feature</span> <span class="op">=</span> <span class="string">&quot;wasm-bindgen&quot;</span>)]</span> {
                <span class="attribute">#[<span class="ident">path</span> <span class="op">=</span> <span class="string">&quot;wasm32_bindgen.rs&quot;</span>]</span> <span class="kw">mod</span> <span class="ident">imp</span>;
            } <span class="kw">else</span> <span class="kw">if</span> <span class="attribute">#[<span class="ident">cfg</span>(<span class="ident">feature</span> <span class="op">=</span> <span class="string">&quot;stdweb&quot;</span>)]</span> {
                <span class="attribute">#[<span class="ident">path</span> <span class="op">=</span> <span class="string">&quot;wasm32_stdweb.rs&quot;</span>]</span> <span class="kw">mod</span> <span class="ident">imp</span>;
            } <span class="kw">else</span> {
                <span class="comment">// Always have an implementation for wasm32-unknown-unknown.</span>
                <span class="comment">// See https://github.com/rust-random/getrandom/issues/87</span>
                <span class="attribute">#[<span class="ident">path</span> <span class="op">=</span> <span class="string">&quot;dummy.rs&quot;</span>]</span> <span class="kw">mod</span> <span class="ident">imp</span>;
            }
        }
    } <span class="kw">else</span> <span class="kw">if</span> <span class="attribute">#[<span class="ident">cfg</span>(<span class="ident">feature</span> <span class="op">=</span> <span class="string">&quot;dummy&quot;</span>)]</span> {
        <span class="attribute">#[<span class="ident">path</span> <span class="op">=</span> <span class="string">&quot;dummy.rs&quot;</span>]</span> <span class="kw">mod</span> <span class="ident">imp</span>;
    } <span class="kw">else</span> {
        <span class="macro">compile_error</span><span class="macro">!</span>(<span class="string">&quot;\
            target is not supported, for more information see: \
            https://docs.rs/getrandom/#unsupported-targets\
        &quot;</span>);
    }
}

<span class="doccomment">/// Fill `dest` with random bytes from the system&#39;s preferred random number</span>
<span class="doccomment">/// source.</span>
<span class="doccomment">///</span>
<span class="doccomment">/// This function returns an error on any failure, including partial reads. We</span>
<span class="doccomment">/// make no guarantees regarding the contents of `dest` on error. If `dest` is</span>
<span class="doccomment">/// empty, `getrandom` immediately returns success, making no calls to the</span>
<span class="doccomment">/// underlying operating system.</span>
<span class="doccomment">///</span>
<span class="doccomment">/// Blocking is possible, at least during early boot; see module documentation.</span>
<span class="doccomment">///</span>
<span class="doccomment">/// In general, `getrandom` will be fast enough for interactive usage, though</span>
<span class="doccomment">/// significantly slower than a user-space CSPRNG; for the latter consider</span>
<span class="doccomment">/// [`rand::thread_rng`](https://docs.rs/rand/*/rand/fn.thread_rng.html).</span>
<span class="kw">pub</span> <span class="kw">fn</span> <span class="ident">getrandom</span>(<span class="ident">dest</span>: <span class="kw-2">&amp;</span><span class="kw-2">mut</span> [<span class="ident">u8</span>]) <span class="op">-</span><span class="op">&gt;</span> <span class="prelude-ty">Result</span><span class="op">&lt;</span>(), <span class="ident">error</span>::<span class="ident">Error</span><span class="op">&gt;</span> {
    <span class="kw">if</span> <span class="ident">dest</span>.<span class="ident">is_empty</span>() {
        <span class="kw">return</span> <span class="prelude-val">Ok</span>(());
    }
    <span class="ident">imp</span>::<span class="ident">getrandom_inner</span>(<span class="ident">dest</span>)
}
</pre></div>
</section><section id="search" class="content hidden"></section><section class="footer"></section><script>window.rootPath = "../../";window.currentCrate = "getrandom";</script><script src="../../main.js"></script><script src="../../source-script.js"></script><script src="../../source-files.js"></script><script defer src="../../search-index.js"></script></body></html>